//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Nov 12 15:17:54 PST 1996
// Last Modified: Tue Apr 29 21:38:49 GMT-0800 1997
// Filename:      SoundFileWrite.h
// Based On:      http://sig.sapp.org/include/sigSignal/SoundFileOut.h
// Syntax:        C++ 
// Copyright:     Copyright 2002 Craig Stuart Sapp
//

#ifndef _SOUNDFILEWRITE_H_INCLUDED
#define _SOUNDFILEWRITE_H_INCLUDED


#include "SoundHeader.h"
#include <fstream.h>


class SoundFileWrite {
   public:
                   SoundFileWrite       (char* aFileName, SoundHeader& header);
                  ~SoundFileWrite       ();

      void         close                (void);
      const char*  getFilename          (void);
      void         writeSample16Bit     (short sample);
      void         writeSampleDouble    (double sample);
 
   protected:
      char        *filename;
      int          endianType;
      SoundHeader  sndHeader;
      FileIO       outFile;
      long         sampleCount;
      ushort       outSample;


      void         determineWritingFunction (void);
      void         (*writeSample)           (FileIO& outFile, double aSample);


};


short SampleToShort(double sample);
char  SampleToChar(double aSample);
long  SampleToLong(double aSample);


#endif  /* _SOUNDFILEWRITE_H_INCLUDED */
